import { BehaviorSubject } from 'rxjs';
type UpdateFunction<T> = (state: T) => T;
type Updater<T> = (cb: UpdateFunction<T>) => void;
type DefaultState<T> = T | {
    hydrator: () => Promise<T>;
    beforeLoadState: T;
    persist?: (state: T) => Promise<void>;
};
interface StoreBuilder<T> {
    defaultState: DefaultState<T>;
    useStore: () => [T, Updater<T>];
    useSelector: <S>(selector: (state: T) => S) => S;
    subject$: BehaviorSubject<T>;
    update: Updater<T>;
    getValue: () => T;
}
export declare const buildClassicStore: <T>(defaultState: DefaultState<T>) => Promise<StoreBuilder<T>>;
export {};
