import { BehaviorSubject, type Observable } from 'rxjs';
import { type GetValueType, type NestedEvent, type PropertyPath, type SystemEvent } from './types';
export declare function createEventStore<T extends object>(initialState: T, options?: {
    debug?: boolean;
    hydrator?: () => Promise<T>;
    persist?: (state: T) => Promise<void>;
}): {
    useStoreValue: <K extends PropertyPath<T>>(type: K) => [GetValueType<T, K>, (payload: GetValueType<T, K>) => void];
    useHydrateStore: () => (payload: T) => void;
    useIsHydrated: () => boolean;
    publish: <TType extends PropertyPath<T>, TPayload extends GetValueType<T, TType>>(type: TType, payload: TPayload) => void;
    getPropertyObservable: <K_1 extends PropertyPath<T>>(eventType: K_1) => Observable<GetValueType<T, K_1>>;
    state$: BehaviorSubject<T>;
    systemEvents$: Observable<NestedEvent<T> | SystemEvent<T>>;
    globalEventStore$: BehaviorSubject<NestedEvent<T> | SystemEvent<T>>;
};
